All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section [parameter=[value] ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It
32 can checkout, update, or perform other actions on
33 a set of repositories as if they were one combined respository. It
34 supports any combination of subversion, git, cvs, and bzr repositories,
35 and support for other revision control systems can easily be added.
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in the mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 By default it registers it to the ~/.mrconfig file. To make it write to a
94 different file, use the -c option.
98 Adds, modifies, removes, or prints a value from the mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
117 Actions can be abbreviated to any unambiguous subsctring, so
118 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
121 Additional parameters can be passed to most commands, and are passed on
122 unchanged to the underlying revision control system. This is mostly useful
123 if the repositories mr will act on all use the same revision control
132 Specifies the topmost directory that B<mr> should work in. The default is
133 the current working directory.
137 Use the specified mrconfig file, instead of looking for one in your home
146 Expand the statistics line displayed at the end to include information
147 about exactly which repositories failed and were skipped, if any.
151 Just operate on the repository for the current directory, do not
152 recurse into deeper repositories.
158 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
159 file in your home directory, and this can in turn chain load .mrconfig files
162 Here is an example .mrconfig file:
165 checkout = svn co svn://svn.example.com/src/trunk src
169 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
171 git checkout -b mybranch origin/master
173 The .mrconfig file uses a variant of the INI file format. Lines starting with
174 "#" are comments. Values can be continued to the following line by
175 indenting the line with whitespace.
177 The "DEFAULT" section allows setting default values for the sections that
180 The "ALIAS" section allows adding aliases for actions. Each parameter
181 is an alias, and its value is the action to use.
183 All other sections add repositories. The section header specifies the
184 directory where the repository is located. This is relative to the directory
185 that contains the mrconfig file, but you can also choose to use absolute
188 Within a section, each parameter defines a shell command to run to handle a
189 given action. mr contains default handlers for the "update", "status", and
190 "commit" actions, so normally you only need to specify what to do for
193 Note that these shell commands are run in a "set -e" shell
194 environment, where any additional parameters you pass are available in
195 "$@". The "checkout" command is run in the parent of the repository
196 directory, since the repository isn't checked out yet. All other commands
197 are run inside the repository, though not necessarily at the top of it.
198 The "MR_REPO" environment variable is set to the path to the top of the
199 repository, and "MR_CONFIG" is set to the topmost .mrconfig file used.
201 A few parameters have special meanings:
207 If the "skip" parameter is set and its command returns nonzero, then B<mr>
208 will skip acting on that repository. The command is passed the action
211 Here are two examples. The first skips the repo unless
212 mr is run by joey. The second uses the hours_since function
213 (included in mr's built-in library) to skip updating the repo unless it's
214 been at least 12 hours since the last update.
216 skip = test $(whoami) != joey
217 skip = [ "$1" = update ] && [ $(hours_since "$1") -lt 12 ]
221 If the "chain" parameter is set and its command returns nonzero, then B<mr>
222 will try to load a .mrconfig file from the root of the repository. (You
223 should avoid chaining from repositories with untrusted committers.)
227 If the "deleted" parameter is set and its command returns nonzero, then
228 B<mr> will treat the repository as deleted. It won't ever actually delete
229 the repository, but it will warn if it sees the repository's directory.
230 This is useful when one mrconfig file is shared amoung multiple machines,
231 to keep track of and remember to delete old repositories.
235 The "lib" parameter can specify some shell code that will be run before each
236 command, this can be a useful way to define shell functions for other commands
243 Copyright 2007 Joey Hess <joey@kitenet.net>
245 Licensed under the GNU GPL version 2 or higher.
247 http://kitenet.net/~joey/code/mr/
256 use Cwd qw(getcwd abs_path);
259 print STDERR "mr: interrupted\n";
263 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
264 my $directory=getcwd();
272 Getopt::Long::Configure("no_permute");
273 my $result=GetOptions(
274 "d|directory=s" => sub { $directory=abs_path($_[1]) },
275 "c|config=s" => sub { $ENV{MR_CONFIG}=abs_path($_[1]) },
276 "v|verbose" => \$verbose,
277 "s|stats" => \$stats,
278 "n|no-recurse" => \$no_recurse,
280 if (! $result || @ARGV < 1) {
281 die("Usage: mr [-d directory] action [params ...]\n".
282 "(Use mr help for man page.)\n");
287 loadconfig($ENV{MR_CONFIG});
289 #print Dumper(\%config);
292 use FindBin qw($Bin $Script);
293 $ENV{MR_PATH}=$Bin."/".$Script;
296 # alias expansion and command stemming
297 my $action=shift @ARGV;
298 if (exists $alias{$action}) {
299 $action=$alias{$action};
301 if (! exists $knownactions{$action}) {
302 my @matches = grep { /^\Q$action\E/ }
303 keys %knownactions, keys %alias;
307 elsif (@matches == 0) {
308 die "mr: unknown action \"$action\" (known actions: ".
309 join(", ", sort keys %knownactions).")\n";
312 die "mr: ambiguous action \"$action\" (matches: ".
313 join(", ", @matches).")\n";
317 if ($action eq 'help') {
318 exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
320 elsif ($action eq 'config') {
322 die "mr config: not enough parameters\n";
325 if ($section=~/^\//) {
326 # try to convert to a path relative to the config file
327 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
328 if ($section=~/^\Q$dir\E(.*)/) {
334 if (/^([^=]+)=(.*)$/) {
335 $changefields{$1}=$2;
339 foreach my $topdir (sort keys %config) {
340 if (exists $config{$topdir}{$section} &&
341 exists $config{$topdir}{$section}{$_}) {
342 print $config{$topdir}{$section}{$_}."\n";
347 die "mr $action: $section $_ not set\n";
351 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
354 elsif ($action eq 'register') {
355 my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
356 "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
357 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
358 print STDERR "mr $action: running >>$command<<\n" if $verbose;
359 exec($command) || die "exec: $!";
362 # work out what repos to act on
365 foreach my $topdir (sort keys %config) {
366 foreach my $subdir (sort keys %{$config{$topdir}}) {
367 next if $subdir eq 'DEFAULT';
368 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
370 $dir.="/" unless $dir=~/\/$/;
371 $d.="/" unless $d=~/\/$/;
372 next if $no_recurse && $d ne $dir;
373 next if $dir ne $d && $dir !~ /^\Q$d\E/;
374 push @repos, [$dir, $topdir, $subdir];
378 # fallback to find a leaf repo
379 LEAF: foreach my $topdir (reverse sort keys %config) {
380 foreach my $subdir (reverse sort keys %{$config{$topdir}}) {
381 next if $subdir eq 'DEFAULT';
382 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
384 $dir.="/" unless $dir=~/\/$/;
385 $d.="/" unless $d=~/\/$/;
386 if ($d=~/^\Q$dir\E/) {
387 push @repos, [$dir, $topdir, $subdir];
395 my (@failed, @ok, @skipped);
396 foreach my $repo (@repos) {
397 action($action, @$repo);
401 my ($action, $dir, $topdir, $subdir) = @_;
403 my $lib= exists $config{$topdir}{$subdir}{lib} ?
404 $config{$topdir}{$subdir}{lib}."\n" : "";
406 if (exists $config{$topdir}{$subdir}{deleted}) {
411 my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
412 print "mr $action: running deleted test >>$test<<\n" if $verbose;
413 my $ret=system($test);
415 if (($? & 127) == 2) {
416 print STDERR "mr $action: interrupted\n";
420 print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
422 if ($ret >> 8 == 0) {
423 print STDERR "mr error: $dir should be deleted yet still exists\n\n";
431 if ($action eq 'checkout') {
433 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
438 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
441 print "mr $action: creating parent directory $dir\n" if $verbose;
442 my $ret=system("mkdir", "-p", $dir);
445 elsif ($action eq 'update') {
447 return action("checkout", $dir, $topdir, $subdir);
453 if (exists $config{$topdir}{$subdir}{skip}) {
454 my $test="set -e;".$lib.
455 "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
456 print "mr $action: running skip test >>$test<<\n" if $verbose;
457 my $ret=system($test);
459 if (($? & 127) == 2) {
460 print STDERR "mr $action: interrupted\n";
464 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
467 if ($ret >> 8 == 0) {
468 print "mr $action: $dir skipped per config file\n" if $verbose;
475 if (! $nochdir && ! chdir($dir)) {
476 print STDERR "mr $action: failed to chdir to $dir: $!\n";
479 elsif (! exists $config{$topdir}{$subdir}{$action}) {
480 print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
485 print "mr $action: $topdir$subdir\n";
488 print "mr $action: $topdir$subdir (in subdir $directory)\n";
490 my $command="set -e; ".$lib.
491 "my_action(){ $config{$topdir}{$subdir}{$action}\n }; my_action ".
492 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
493 print STDERR "mr $action: running >>$command<<\n" if $verbose;
494 my $ret=system($command);
496 if (($? & 127) == 2) {
497 print STDERR "mr $action: interrupted\n";
501 print STDERR "mr $action: received signal ".($? & 127)."\n";
503 print STDERR "mr $action: failed ($ret)\n" if $verbose;
505 if ($ret >> 8 != 0) {
506 print STDERR "mr $action: command failed\n";
509 print STDERR "mr $action: command died ($ret)\n";
513 if ($action eq 'checkout' && ! -d $dir) {
514 print STDERR "mr $action: $dir missing after checkout\n";;
531 return "$count ".($count > 1 ? $plural : $singular);
535 if (! @ok && ! @failed && ! @skipped) {
536 die "mr $action: no repositories found to work on\n";
538 print "mr $action: finished (".join("; ",
539 showstat($#ok+1, "ok", "ok"),
540 showstat($#failed+1, "failed", "failed"),
541 showstat($#skipped+1, "skipped", "skipped"),
545 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
548 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
554 elsif (! @ok && @skipped) {
560 sub loadconfig { #{{{
567 if (ref $f eq 'GLOB') {
576 my $absf=abs_path($f);
577 if ($loaded{$absf}) {
582 ($dir)=$f=~/^(.*\/)[^\/]+$/;
583 if (! defined $dir) {
586 $dir=abs_path($dir)."/";
588 # copy in defaults from first parent
590 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
591 if ($parent eq '/') {
594 if (exists $config{$parent} &&
595 exists $config{$parent}{DEFAULT}) {
596 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
601 print "mr: loading config $f\n" if $verbose;
602 open($in, "<", $f) || die "mr: open $f: $!\n";
613 next if /^\s*\#/ || /^\s*$/;
614 if (/^\[([^\]]*)\]\s*$/) {
617 elsif (/^(\w+)\s*=\s*(.*)/) {
622 while (@lines && $lines[0]=~/^\s(.+)/) {
629 if (! defined $section) {
630 die "$f line $.: parameter ($parameter) not in section\n";
632 if ($section ne 'ALIAS' &&
633 ! exists $config{$dir}{$section} &&
634 exists $config{$dir}{DEFAULT}) {
636 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
638 if ($section eq 'ALIAS') {
639 $alias{$parameter}=$value;
641 elsif ($parameter eq 'lib') {
642 $config{$dir}{$section}{lib}.=$value."\n";
645 $config{$dir}{$section}{$parameter}=$value;
646 $knownactions{$parameter}=1;
647 if ($parameter eq 'chain' &&
648 length $dir && $section ne "DEFAULT" &&
649 -e $dir.$section."/.mrconfig") {
650 my $ret=system($value);
652 if (($? & 127) == 2) {
653 print STDERR "mr $action: chain test interrupted\n";
657 print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
661 push @toload, $dir.$section."/.mrconfig";
667 die "$f line $line: parse error\n";
676 sub modifyconfig { #{{{
678 # the section to modify or add
679 my $targetsection=shift;
680 # fields to change in the section
681 # To remove a field, set its value to "".
688 open(my $in, "<", $f) || die "mr: open $f: $!\n";
693 my $formatfield=sub {
695 my @value=split(/\n/, shift);
697 return "$field = ".shift(@value)."\n".
698 join("", map { "\t$_\n" } @value);
702 while ($out[$#out] =~ /^\s*$/) {
703 unshift @blanks, pop @out;
705 foreach my $field (sort keys %changefields) {
706 if (length $changefields{$field}) {
707 push @out, "$field = $changefields{$field}\n";
708 delete $changefields{$field};
718 if (/^\s*\#/ || /^\s*$/) {
721 elsif (/^\[([^\]]*)\]\s*$/) {
722 if (defined $section &&
723 $section eq $targetsection) {
731 elsif (/^(\w+)\s*=\s(.*)/) {
736 while (@lines && $lines[0]=~/^\s(.+)/) {
742 if ($section eq $targetsection) {
743 if (exists $changefields{$parameter}) {
744 if (length $changefields{$parameter}) {
745 $value=$changefields{$parameter};
747 delete $changefields{$parameter};
751 push @out, $formatfield->($parameter, $value);
755 if (defined $section &&
756 $section eq $targetsection) {
759 elsif (%changefields) {
760 push @out, "\n[$targetsection]\n";
761 foreach my $field (sort keys %changefields) {
762 if (length $changefields{$field}) {
763 push @out, $formatfield->($field, $changefields{$field});
768 open(my $out, ">", $f) || die "mr: write $f: $!\n";
773 # Finally, some useful actions that mr knows about by default.
774 # These can be overridden in ~/.mrconfig.
789 for dir in .git .svn .bzr CVS; do
790 if [ -e "$MR_REPO/$dir" ]; then
791 flagfile="$MR_REPO/$dir/.mr_last$1"
795 if [ -z "$flagfile" ]; then
796 error "cannot determine flag filename"
798 perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"
803 if [ -d "$MR_REPO"/.svn ]; then
805 elif [ -d "$MR_REPO"/.git ]; then
806 git pull origin master "$@"
807 elif [ -d "$MR_REPO"/.bzr ]; then
809 elif [ -d "$MR_REPO"/CVS ]; then
812 error "unknown repo type"
815 if [ -d "$MR_REPO"/.svn ]; then
817 elif [ -d "$MR_REPO"/.git ]; then
818 git status "$@" || true
819 elif [ -d "$MR_REPO"/.bzr ]; then
821 elif [ -d "$MR_REPO"/CVS ]; then
824 error "unknown repo type"
827 if [ -d "$MR_REPO"/.svn ]; then
829 elif [ -d "$MR_REPO"/.git ]; then
830 git commit -a "$@" && git push --all
831 elif [ -d "$MR_REPO"/.bzr ]; then
832 bzr commit "$@" && bzr push
833 elif [ -d "$MR_REPO"/CVS ]; then
836 error "unknown repo type"
839 if [ -d "$MR_REPO"/.svn ]; then
841 elif [ -d "$MR_REPO"/.git ]; then
843 elif [ -d "$MR_REPO"/.bzr ]; then
845 elif [ -d "$MR_REPO"/CVS ]; then
848 error "unknown repo type"
851 if [ -d "$MR_REPO"/.svn ]; then
853 elif [ -d "$MR_REPO"/.git ]; then
855 elif [ -d "$MR_REPO"/.bzr ]; then
857 elif [ -d "$MR_REPO"/CVS ]; then
860 error "unknown repo type"
866 basedir="$(basename $(pwd))"
868 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
869 if [ -z "$url" ]; then
870 error "cannot determine svn url"
872 echo "Registering svn url: $url"
873 mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
874 elif [ -d .git ]; then
875 url=$(LANG=C git-config --get remote.origin.url)
876 if [ -z "$url" ]; then
877 error "cannot determine git url"
879 echo "Registering git url: $url"
880 mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
881 elif [ -d .bzr ]; then
882 url=$(cat .bzr/branch/parent)
883 if [ -z "$url" ]; then
884 error "cannot determine bzr url"
886 echo "Registering bzr url: $url"
887 mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
889 error "unable to register this repo type"
892 if [ ! -e "$MR_PATH" ]; then
893 error "cannot find program path"
895 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
899 ed = echo "A horse is a horse, of course, of course.."
900 T = echo "I pity the fool."
901 right = echo "Not found."